!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SubRoutine NeumannElement                                                &   
     &                 ( AE,BE,MaxLRows,XLL,NDim,iDofT,NodELT,                 & 
     &                   Sol0,Sol1,CommonPar,                                  &
     &                   Param,JParam,DelT,DTm,Time)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
      IMPLICIT REAL*8 (A-H,O-Z)

      Parameter (PI = 3.141592653589793238D0)
      Parameter (Theta = 1.0D0 )
      Parameter (Theta1= 1.0d0-Theta )

      Parameter ( NGP = 4 )
      Logical OnlyVertex
      Parameter ( iSimplex = 0 ,iBU=0 )
      
      DIMENSION AE(MaxLRows,MaxLRows), BE(MaxLRows),                               &
     & XLL(1),Sol0(1),Sol1(1),                                                     &
     & QC(NodELT),Pm(NodELT),XL(NDim*(NodElT)),                                    &
     & Param(1), JParam(1),CommonPar(1),                                           &
     & Vel0(Ndim),Vel1(Ndim),Pres(NodELT),                                         &
     & Vn(3),XA(3),XB(3),                                                          &
     & Psi(NDim-1,NGP),W(NGP),                                                     &
     & dFi1_L(NDim,NodElT),dFi2_L(NDim,NodElT),                                    &
     & dFi2_G(NDim,NodElT),                                                        &
     & Fi1(NodElT),Fi2(NodElT),dFi2i(NDim),Vt(3)
       Real*8 Jac(NDim,NDim)


      Cond = CommonPar(1)
      CN   = CommonPar(2)
      CN   = dsign( 1.0d0, CN)

      NodEL = NodELT 
      NdimE1 = Ndim
      NdimE = NdimE1 - 1        

      NodG    = Ndim
      NDimG   = NdimE1

      Do Nod=1, NodEl
          iPNod = (Nod-1)*Ndim 
          Do nsd=1, NDim
              XL(iPNod + nsd) =XLL(iPNod + nsd)
          End Do
      End Do

! Side Vectors
      XA(1) = XL(3) - XL(1)  
      XA(2) = XL(4) - XL(2)  
      XA(3) = 0.0d0
        
      XB(1) = 0.0d0  
      XB(2) = 0.0d0
      XB(3) = 1.0d0
 !Normal Vector Vn      
      Call ProductoVectorial ( XA , XB , Vn , DA ) 
      Vn = Vn/DA*CN

!------------------------------------
!     Psi: Gauss Points Matrix, W: Weights
      Call GaussRule (Psi,W,NDimE,NGP,iSimplex)    

      Det = DA*CN
!--------------------------
      LoopGaussPoints: Do nG = 1, NGP
!--------------------------
      Call ShapeF (NodEL,NDimE,Fi1,PSI(1,nG),1,iBu)
      DS = Det*W(nG)
      LoopRow: Do i=1,NodEL
          ipRow   = (i-1)*iDofT + 1
          BE(ipRow) = BE(ipRow) + Cond*Fi1(i)*DS
      End Do LoopRow
!--------------------------
      End Do LoopGaussPoints
!--------------------------

      Return
      End
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






