!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SubRoutine PoissonFEM_1                                                    &
     &           ( AE,BE,MaxLRows,XLL,NDim,iDofT,NodELT,                         &
     &             Sol0,Sol1,CommonPar,                                          &
     &             Param,JParam,DelT,DTm,Time)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT REAL*8 (A-H,O-Z)

      Parameter (PI = 3.141592653589793238D0)
!      Parameter (Theta = 1.0D0 )
      Parameter (Ls1 = 1 )
      Parameter (Ls2 = 0 )
!     NdimE: dimensionality of the triangle element,
!     it could be hapen that we use a 2d element in a 3d problem. 
!     NGP= Number of gauus points
! dependeria de Ndim y Integration order rule
! los dos tendrian que ir en ElemLib, porque se necesita
! la dimension del elemento, No esta implicito en el tipo de elemento
!  usado, aunque esto hace que no se pueda usar el mismo codigo
! para 2D y 3D
!      Parameter (NodEL = 3 )
!      Parameter (NdimE = 2 )
!      Parameter (	NGP = 7 )
      Parameter ( iSimplex = 0 , iBU=0 )
      Real*8 Jac(Ndim,Ndim)
      Logical OnlyVertex, Linear

      DIMENSION AE(MaxLRows,MaxLRows), BE(MaxLRows),                           &
     &  XLL(*),Sol0(*),Sol1(*),                                                &
     &  Param(*), JParam(*),CommonPar(*),                                      &
     &  Gravity(Ndim),Psi(Ndim,40),W(40),                                      &
     &  dFi1_L(Ndim,NodElT),dFi_L(Ndim,NodElT),dFi_G(Ndim,NodELT),            &
     &  Fi1(NodElT),Fi(NodElT),dFi_i(Ndim),XL(Ndim*(NodELT+1))
      Real*8 , Save :: Mass(11,11),MassL(11)

      NodEl = NodELT
      NdimE = NDim     
      Ro    = CommonPar(1)
      Rot   = Ro/Dtm
      Cv    = CommonPar(2)
      Cond  = CommonPar(3)
      Gamma = CommonPar(4)
      Last = 5
      Theta   = CommonPar(Last)
      Theta1 = 1.0d0 - Theta

      Do Nod=1, NodEL
          Do nci=1, NdimE
              XL( (Nod-1)*NdimE + nci ) = XLL( (Nod-1)*Ndim + nci)      
          End Do
      End Do

      NGP = 4

      NodG = 3

      iorder = 1
!      iorder = 2

!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
! Mass Matrix Calculation

      Call GaussRule (Psi,W,NdimE,NGP,iSimplex)
      Mass  = 0.0d0
      Volume= 0.0d0
!-----------------------------------------------------------------------
      LoopGaussP: Do nG=1,NGP
!-----------------------------------------------------------------------
!     dFi1_L = first derivatives with respect to intrinsic Local coordinates
!              refers to linear shape functions
!     dFi1_G = first derivatives with respect to Global coordinates
!     dFi2_L = first derivatives with respect to intrinsic Local coordinates
!              refers to Cuadratic shape functions

!     Call LocalShapeDer(NodG+iBu,NdimE,dFi1_L,PSI(1,nG),1,iBu)
      Call LocalShapeDer(NodEL,NdimE,dFi_L,PSI(1,nG),iorder,iBu)
      Call Jacobian(Jac,Det,NdimE,NodG,XL,dFi_L)

      Call ShapeF (NodEL,NdimE,Fi,PSI(1,nG),iorder,iBu)

      DV = W(nG)
      Volume = Volume + DV

      Do i=1,NodEL
          Do j=1,NodEL
              Mass(i,j) = Mass(i,j) + Fi(i) * Fi(j) * DV
          End Do
      End Do

!-----------------------------------------------------------------------
      EndDo LoopGaussP
!-----------------------------------------------------------------------

!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


!     Psi: Gauss Points Matrix, W: Weights
      Call GaussRule (Psi,W,NdimE,NGP,iSimplex)    
      Volume=0.0d0
!--------------------------
      LoopGaussPoints: Do nG = 1, NGP
!--------------------------
!     dFi1_L = first derivatives with respect to intrinsic Local coordinates
!              refers to linear shape functions
!     dFi1_G = first derivatives with respect to Global coordinates
!     dFi2_L = first derivatives with respect to intrinsic Local coordinates
!              refers to Cuadratic shape functions

!      Call LocalShapeDer(NodG+iBu,NdimE,dFi1_L,PSI(1,nG),1,iBu)
      If (nG .eq. 1) then
          Call LocalShapeDer(NodEL,NdimE,dFi_L,PSI(1,nG),iorder,iBu)
          Call Jacobian(Jac,Det,NdimE,NodG,XL,dFi_L)
      End If
      Call GlobalShapeDer(NodEL,NdimE,dFi_L,dFi_G,Jac)
      Call ShapeF (NodEL,NdimE,Fi,PSI(1,nG),iorder,iBu)

      DV = Det*W(nG)

      Volume = Volume + DV

      CK = Cond * DV 
      LoopRow: Do i=1,NodEL
          ipRow  = (i-1)*iDofT
          ipRow1 = ipRow + 1
          Fi_i = Fi(i)
          Do nci=1, NdimE
              dFi_i(nci) = dFi_G(nci,i)
          End Do

          BE( ipRow1 ) = BE( ipRow1 )+ Ro*Gamma*Fi_i*DV 

          LoopCol: Do j=1,NodEL
              ipCol  = (j-1)*iDofT 
              ipCol1 = ipCol + 1
              Do nci=1, NdimE
                  dFi_j_nci = dFi_G(nci,j) 
                  AE(ipRow1 , ipCol1)= AE(ipRow1 , ipCol1) + Theta*CK* dFi_i(nci)*dFi_j_nci
                  BE(ipRow1)= BE(ipRow1) - Theta1*CK*dFi_i(nci)*dFi_j_nci*Sol0(ipCol1)
              End Do                                            
          End Do LoopCol
!-----------------------------------------------
      End Do LoopRow
!--------------------------
      End Do LoopGaussPoints
!--------------------------

      Volume = Volume*2.0d0

      Do i=1,NodEL
          ipRow  = (i-1)*iDofT
          ipRow1 = ipRow + 1
          Do j=1,NodEL
              ipCol  = (j-1)*iDofT 
              ipCol1 = ipCol + 1
              AE(ipRow1,ipCol1) = AE(ipRow1,ipCol1) + Mass(i,j)*Volume*Rot*Cv
              BE(ipRow1) = BE(ipRow1) + Mass(i,j)*Volume*Rot*Cv*Sol0(ipCol1)
          End Do
      End Do 

      Return
      End


